diff -uNr jfbterm-0.4.7.orig/install-sh jfbterm-0.4.7/install-sh
--- jfbterm-0.4.7.orig/install-sh	2002-07-17 01:21:23.000000000 +0900
+++ jfbterm-0.4.7/install-sh	2005-12-17 12:41:37.000000000 +0900
@@ -1,19 +1,38 @@
 #!/bin/sh
-#
 # install - install a program, script, or datafile
-# This comes from X11R5 (mit/util/scripts/install.sh).
+
+scriptversion=2005-02-02.21
+
+# This originates from X11R5 (mit/util/scripts/install.sh), which was
+# later released in X11R6 (xc/config/util/install.sh) with the
+# following copyright and license.
+#
+# Copyright (C) 1994 X Consortium
+#
+# Permission is hereby granted, free of charge, to any person obtaining a copy
+# of this software and associated documentation files (the "Software"), to
+# deal in the Software without restriction, including without limitation the
+# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
+# sell copies of the Software, and to permit persons to whom the Software is
+# furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included in
+# all copies or substantial portions of the Software.
 #
-# Copyright 1991 by the Massachusetts Institute of Technology
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
+# X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
+# AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNEC-
+# TION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 #
-# Permission to use, copy, modify, distribute, and sell this software and its
-# documentation for any purpose is hereby granted without fee, provided that
-# the above copyright notice appear in all copies and that both that
-# copyright notice and this permission notice appear in supporting
-# documentation, and that the name of M.I.T. not be used in advertising or
-# publicity pertaining to distribution of the software without specific,
-# written prior permission.  M.I.T. makes no representations about the
-# suitability of this software for any purpose.  It is provided "as is"
-# without express or implied warranty.
+# Except as contained in this notice, the name of the X Consortium shall not
+# be used in advertising or otherwise to promote the sale, use or other deal-
+# ings in this Software without prior written authorization from the X Consor-
+# tium.
+#
+#
+# FSF changes to this file are in the public domain.
 #
 # Calling this script install-sh is preferred over install.sh, to prevent
 # `make' implicit rules from creating a file called install from it
@@ -23,13 +42,11 @@
 # from scratch.  It can only install one file at a time, a restriction
 # shared with many OS's install programs.
 
-
 # set DOITPROG to echo to test this script
 
 # Don't use :- since 4.3BSD and earlier shells don't like it.
 doit="${DOITPROG-}"
 
-
 # put in absolute paths if you don't have them in your path; or use env. vars.
 
 mvprog="${MVPROG-mv}"
@@ -41,211 +58,266 @@
 rmprog="${RMPROG-rm}"
 mkdirprog="${MKDIRPROG-mkdir}"
 
-transformbasename=""
-transform_arg=""
-instcmd="$mvprog"
 chmodcmd="$chmodprog 0755"
-chowncmd=""
-chgrpcmd=""
-stripcmd=""
+chowncmd=
+chgrpcmd=
+stripcmd=
 rmcmd="$rmprog -f"
 mvcmd="$mvprog"
-src=""
-dst=""
-dir_arg=""
-
-while [ x"$1" != x ]; do
-    case $1 in
-	-c) instcmd="$cpprog"
-	    shift
-	    continue;;
-
-	-d) dir_arg=true
-	    shift
-	    continue;;
-
-	-m) chmodcmd="$chmodprog $2"
-	    shift
-	    shift
-	    continue;;
-
-	-o) chowncmd="$chownprog $2"
-	    shift
-	    shift
-	    continue;;
-
-	-g) chgrpcmd="$chgrpprog $2"
-	    shift
-	    shift
-	    continue;;
-
-	-s) stripcmd="$stripprog"
-	    shift
-	    continue;;
-
-	-t=*) transformarg=`echo $1 | sed 's/-t=//'`
-	    shift
-	    continue;;
-
-	-b=*) transformbasename=`echo $1 | sed 's/-b=//'`
-	    shift
-	    continue;;
-
-	*)  if [ x"$src" = x ]
-	    then
-		src=$1
-	    else
-		# this colon is to work around a 386BSD /bin/sh bug
-		:
-		dst=$1
-	    fi
-	    shift
-	    continue;;
-    esac
-done
-
-if [ x"$src" = x ]
-then
-	echo "install:	no input file specified"
-	exit 1
-else
-	true
-fi
-
-if [ x"$dir_arg" != x ]; then
-	dst=$src
-	src=""
-	
-	if [ -d $dst ]; then
-		instcmd=:
-		chmodcmd=""
-	else
-		instcmd=mkdir
-	fi
-else
-
-# Waiting for this to be detected by the "$instcmd $src $dsttmp" command
-# might cause directories to be created, which would be especially bad 
-# if $src (and thus $dsttmp) contains '*'.
-
-	if [ -f $src -o -d $src ]
-	then
-		true
-	else
-		echo "install:  $src does not exist"
-		exit 1
-	fi
-	
-	if [ x"$dst" = x ]
-	then
-		echo "install:	no destination specified"
-		exit 1
-	else
-		true
-	fi
-
-# If destination is a directory, append the input filename; if your system
-# does not like double slashes in filenames, you may need to add some logic
-
-	if [ -d $dst ]
-	then
-		dst="$dst"/`basename $src`
-	else
-		true
-	fi
-fi
-
-## this sed command emulates the dirname command
-dstdir=`echo $dst | sed -e 's,[^/]*$,,;s,/$,,;s,^$,.,'`
-
-# Make sure that the destination directory exists.
-#  this part is taken from Noah Friedman's mkinstalldirs script
+src=
+dst=
+dir_arg=
+dstarg=
+no_target_directory=
+
+usage="Usage: $0 [OPTION]... [-T] SRCFILE DSTFILE
+   or: $0 [OPTION]... SRCFILES... DIRECTORY
+   or: $0 [OPTION]... -t DIRECTORY SRCFILES...
+   or: $0 [OPTION]... -d DIRECTORIES...
+
+In the 1st form, copy SRCFILE to DSTFILE.
+In the 2nd and 3rd, copy all SRCFILES to DIRECTORY.
+In the 4th, create DIRECTORIES.
+
+Options:
+-c         (ignored)
+-d         create directories instead of installing files.
+-g GROUP   $chgrpprog installed files to GROUP.
+-m MODE    $chmodprog installed files to MODE.
+-o USER    $chownprog installed files to USER.
+-s         $stripprog installed files.
+-t DIRECTORY  install into DIRECTORY.
+-T         report an error if DSTFILE is a directory.
+--help     display this help and exit.
+--version  display version info and exit.
+
+Environment variables override the default commands:
+  CHGRPPROG CHMODPROG CHOWNPROG CPPROG MKDIRPROG MVPROG RMPROG STRIPPROG
+"
+
+while test -n "$1"; do
+  case $1 in
+    -c) shift
+        continue;;
+
+    -d) dir_arg=true
+        shift
+        continue;;
+
+    -g) chgrpcmd="$chgrpprog $2"
+        shift
+        shift
+        continue;;
+
+    --help) echo "$usage"; exit $?;;
+
+    -m) chmodcmd="$chmodprog $2"
+        shift
+        shift
+        continue;;
+
+    -o) chowncmd="$chownprog $2"
+        shift
+        shift
+        continue;;
+
+    -s) stripcmd=$stripprog
+        shift
+        continue;;
 
-# Skip lots of stat calls in the usual case.
-if [ ! -d "$dstdir" ]; then
-defaultIFS='	
-'
-IFS="${IFS-${defaultIFS}}"
-
-oIFS="${IFS}"
-# Some sh's can't handle IFS=/ for some reason.
-IFS='%'
-set - `echo ${dstdir} | sed -e 's@/@%@g' -e 's@^%@/@'`
-IFS="${oIFS}"
-
-pathcomp=''
+    -t) dstarg=$2
+	shift
+	shift
+	continue;;
 
-while [ $# -ne 0 ] ; do
-	pathcomp="${pathcomp}${1}"
+    -T) no_target_directory=true
 	shift
+	continue;;
 
-	if [ ! -d "${pathcomp}" ] ;
-        then
-		$mkdirprog "${pathcomp}"
-	else
-		true
-	fi
+    --version) echo "$0 $scriptversion"; exit $?;;
 
-	pathcomp="${pathcomp}/"
+    *)  # When -d is used, all remaining arguments are directories to create.
+	# When -t is used, the destination is already specified.
+	test -n "$dir_arg$dstarg" && break
+        # Otherwise, the last argument is the destination.  Remove it from $@.
+	for arg
+	do
+          if test -n "$dstarg"; then
+	    # $@ is not empty: it contains at least $arg.
+	    set fnord "$@" "$dstarg"
+	    shift # fnord
+	  fi
+	  shift # arg
+	  dstarg=$arg
+	done
+	break;;
+  esac
 done
-fi
-
-if [ x"$dir_arg" != x ]
-then
-	$doit $instcmd $dst &&
-
-	if [ x"$chowncmd" != x ]; then $doit $chowncmd $dst; else true ; fi &&
-	if [ x"$chgrpcmd" != x ]; then $doit $chgrpcmd $dst; else true ; fi &&
-	if [ x"$stripcmd" != x ]; then $doit $stripcmd $dst; else true ; fi &&
-	if [ x"$chmodcmd" != x ]; then $doit $chmodcmd $dst; else true ; fi
-else
-
-# If we're going to rename the final executable, determine the name now.
-
-	if [ x"$transformarg" = x ] 
-	then
-		dstfile=`basename $dst`
-	else
-		dstfile=`basename $dst $transformbasename | 
-			sed $transformarg`$transformbasename
-	fi
-
-# don't allow the sed command to completely eliminate the filename
-
-	if [ x"$dstfile" = x ] 
-	then
-		dstfile=`basename $dst`
-	else
-		true
-	fi
-
-# Make a temp file name in the proper directory.
-
-	dsttmp=$dstdir/#inst.$$#
-
-# Move or copy the file name to the temp name
 
-	$doit $instcmd $src $dsttmp &&
-
-	trap "rm -f ${dsttmp}" 0 &&
-
-# and set any options; do chmod last to preserve setuid bits
-
-# If any of these fail, we abort the whole thing.  If we want to
-# ignore errors from any of these, just make sure not to ignore
-# errors from the above "$doit $instcmd $src $dsttmp" command.
-
-	if [ x"$chowncmd" != x ]; then $doit $chowncmd $dsttmp; else true;fi &&
-	if [ x"$chgrpcmd" != x ]; then $doit $chgrpcmd $dsttmp; else true;fi &&
-	if [ x"$stripcmd" != x ]; then $doit $stripcmd $dsttmp; else true;fi &&
-	if [ x"$chmodcmd" != x ]; then $doit $chmodcmd $dsttmp; else true;fi &&
-
-# Now rename the file to the real destination.
-
-	$doit $rmcmd -f $dstdir/$dstfile &&
-	$doit $mvcmd $dsttmp $dstdir/$dstfile 
+if test -z "$1"; then
+  if test -z "$dir_arg"; then
+    echo "$0: no input file specified." >&2
+    exit 1
+  fi
+  # It's OK to call `install-sh -d' without argument.
+  # This can happen when creating conditional directories.
+  exit 0
+fi
 
-fi &&
+for src
+do
+  # Protect names starting with `-'.
+  case $src in
+    -*) src=./$src ;;
+  esac
+
+  if test -n "$dir_arg"; then
+    dst=$src
+    src=
+
+    if test -d "$dst"; then
+      mkdircmd=:
+      chmodcmd=
+    else
+      mkdircmd=$mkdirprog
+    fi
+  else
+    # Waiting for this to be detected by the "$cpprog $src $dsttmp" command
+    # might cause directories to be created, which would be especially bad
+    # if $src (and thus $dsttmp) contains '*'.
+    if test ! -f "$src" && test ! -d "$src"; then
+      echo "$0: $src does not exist." >&2
+      exit 1
+    fi
+
+    if test -z "$dstarg"; then
+      echo "$0: no destination specified." >&2
+      exit 1
+    fi
+
+    dst=$dstarg
+    # Protect names starting with `-'.
+    case $dst in
+      -*) dst=./$dst ;;
+    esac
 
+    # If destination is a directory, append the input filename; won't work
+    # if double slashes aren't ignored.
+    if test -d "$dst"; then
+      if test -n "$no_target_directory"; then
+	echo "$0: $dstarg: Is a directory" >&2
+	exit 1
+      fi
+      dst=$dst/`basename "$src"`
+    fi
+  fi
+
+  # This sed command emulates the dirname command.
+  dstdir=`echo "$dst" | sed -e 's,/*$,,;s,[^/]*$,,;s,/*$,,;s,^$,.,'`
+
+  # Make sure that the destination directory exists.
+
+  # Skip lots of stat calls in the usual case.
+  if test ! -d "$dstdir"; then
+    defaultIFS='
+	 '
+    IFS="${IFS-$defaultIFS}"
+
+    oIFS=$IFS
+    # Some sh's can't handle IFS=/ for some reason.
+    IFS='%'
+    set x `echo "$dstdir" | sed -e 's@/@%@g' -e 's@^%@/@'`
+    shift
+    IFS=$oIFS
+
+    pathcomp=
+
+    while test $# -ne 0 ; do
+      pathcomp=$pathcomp$1
+      shift
+      if test ! -d "$pathcomp"; then
+        $mkdirprog "$pathcomp"
+	# mkdir can fail with a `File exist' error in case several
+	# install-sh are creating the directory concurrently.  This
+	# is OK.
+	test -d "$pathcomp" || exit
+      fi
+      pathcomp=$pathcomp/
+    done
+  fi
+
+  if test -n "$dir_arg"; then
+    $doit $mkdircmd "$dst" \
+      && { test -z "$chowncmd" || $doit $chowncmd "$dst"; } \
+      && { test -z "$chgrpcmd" || $doit $chgrpcmd "$dst"; } \
+      && { test -z "$stripcmd" || $doit $stripcmd "$dst"; } \
+      && { test -z "$chmodcmd" || $doit $chmodcmd "$dst"; }
+
+  else
+    dstfile=`basename "$dst"`
+
+    # Make a couple of temp file names in the proper directory.
+    dsttmp=$dstdir/_inst.$$_
+    rmtmp=$dstdir/_rm.$$_
+
+    # Trap to clean up those temp files at exit.
+    trap 'ret=$?; rm -f "$dsttmp" "$rmtmp" && exit $ret' 0
+    trap '(exit $?); exit' 1 2 13 15
+
+    # Copy the file name to the temp name.
+    $doit $cpprog "$src" "$dsttmp" &&
+
+    # and set any options; do chmod last to preserve setuid bits.
+    #
+    # If any of these fail, we abort the whole thing.  If we want to
+    # ignore errors from any of these, just make sure not to ignore
+    # errors from the above "$doit $cpprog $src $dsttmp" command.
+    #
+    { test -z "$chowncmd" || $doit $chowncmd "$dsttmp"; } \
+      && { test -z "$chgrpcmd" || $doit $chgrpcmd "$dsttmp"; } \
+      && { test -z "$stripcmd" || $doit $stripcmd "$dsttmp"; } \
+      && { test -z "$chmodcmd" || $doit $chmodcmd "$dsttmp"; } &&
+
+    # Now rename the file to the real destination.
+    { $doit $mvcmd -f "$dsttmp" "$dstdir/$dstfile" 2>/dev/null \
+      || {
+	   # The rename failed, perhaps because mv can't rename something else
+	   # to itself, or perhaps because mv is so ancient that it does not
+	   # support -f.
+
+	   # Now remove or move aside any old file at destination location.
+	   # We try this two ways since rm can't unlink itself on some
+	   # systems and the destination file might be busy for other
+	   # reasons.  In this case, the final cleanup might fail but the new
+	   # file should still install successfully.
+	   {
+	     if test -f "$dstdir/$dstfile"; then
+	       $doit $rmcmd -f "$dstdir/$dstfile" 2>/dev/null \
+	       || $doit $mvcmd -f "$dstdir/$dstfile" "$rmtmp" 2>/dev/null \
+	       || {
+		 echo "$0: cannot unlink or rename $dstdir/$dstfile" >&2
+		 (exit 1); exit 1
+	       }
+	     else
+	       :
+	     fi
+	   } &&
+
+	   # Now rename the file to the real destination.
+	   $doit $mvcmd "$dsttmp" "$dstdir/$dstfile"
+	 }
+    }
+  fi || { (exit 1); exit 1; }
+done
 
-exit 0
+# The final little trick to "correctly" pass the exit status to the exit trap.
+{
+  (exit 0); exit 0
+}
+
+# Local variables:
+# eval: (add-hook 'write-file-hooks 'time-stamp)
+# time-stamp-start: "scriptversion="
+# time-stamp-format: "%:y-%02m-%02d.%02H"
+# time-stamp-end: "$"
+# End:
diff -uNr jfbterm-0.4.7.orig/jfbterm.conf.sample jfbterm-0.4.7/jfbterm.conf.sample
--- jfbterm-0.4.7.orig/jfbterm.conf.sample	2003-09-16 00:16:35.000000000 +0900
+++ jfbterm-0.4.7/jfbterm.conf.sample	2005-12-17 12:41:37.000000000 +0900
@@ -1,25 +1,37 @@
-###############################################################################
 #
-#	jfbterm configuration file
+# jfbterm configuration file
 #
-###############################################################################
 
-###############################################################################
 #
-#	Genral configuration
+# Genral configuration
 #
-###############################################################################
-#	TERM environment variable (default: TERM=jfbterm)
-term		:	jfbterm
 
+# TERM environment variable (default: TERM=jfbterm)
+term: jfbterm
 
-###############################################################################
 #
-#	Font configuration
-#	Absolute path or relative path to PWD
+# Input configuration (libhangul)
 #
-###############################################################################
-fontset : iso646-1973irv,pcf,L,/usr/X11R6/lib/X11/fonts/misc/8x16.pcf.gz
+
+# input type (default: locale)
+input: locale
+#input: euc-kr
+#input: utf-8
+
+# keyboard type (2 is dubulsik, 3 is sebulsik final, ...)
+keyboard: 2
+#keyboard: 3
+#keyboard: 3final
+#keyboard: 390
+#keyboard: 3noshift
+#keyboard: 3yetgul
+
+#
+# Font configuration
+#
+
+# Absolute path or relative path to PWD
+fontset: iso646-1973irv,pcf,L,/usr/X11R6/lib/X11/fonts/misc/8x16.pcf.gz
 +fontset: ansix3.4-1968,alias,L,iso646-1973irv
 +fontset: jisc6226-1978,pcf,L,/usr/X11R6/lib/X11/fonts/misc/jiskan16.pcf.gz
 +fontset: jisx0208-1983,alias,L,jisc6226-1978
@@ -43,55 +55,56 @@
 +fontset: vt100-graphics,pcf,L,/usr/share/fonts/jfbterm/vt100-graphics.pcf.gz
 +fontset: iso10646.1,pcf,U,/usr/X11R6/lib/X11/fonts/misc/unifont.pcf.gz
 
-
-###############################################################################
 #
-#	Encoding configuration 
+# Encoding configuration 
 #
-###############################################################################
+
 encoding : locale
 
-encoding.C     : G0,G1,ansix3.4-1968,ansix3.4-1968,iso8859.1-1987,ansix3.4-1968
-encoding.POSIX : G0,G1,ansix3.4-1968,ansix3.4-1968,iso8859.1-1987,ansix3.4-1968
-encoding.ANSI_X3.4-1968 : G0,G1,ansix3.4-1968,ansix3.4-1968,ansix3.4-1968,ansix3.4-1968
-encoding.EUC-JP : G0,G1,ansix3.4-1968,jisx0208-1983,jisc6220-1969kana,jisx0212-1990
-encoding.EUC-KR : G0,G1,ansix3.4-1968,ksc5601-1987,ansix3.4-1968,ansix3.4-1968
-encoding.GB2312 : G0,G1,ansix3.4-1968,gb2312-80,ansix3.4-1968,ansix3.4-1968
-encoding.ISO-8859-1 : G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.1-1987,ansix3.4-1968
-encoding.ISO-8859-2 : G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.2-1987,ansix3.4-1968
-encoding.ISO-8859-3 : G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.3-1987,ansix3.4-1968
-encoding.ISO-8859-4 : G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.4-1988,ansix3.4-1968
-encoding.ISO-8859-5 : G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.5-1988,ansix3.4-1968
-encoding.ISO-8859-6 : G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.6-1987,ansix3.4-1968
-encoding.ISO-8859-7 : G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.7-1987,ansix3.4-1968
-encoding.ISO-8859-8 : G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.8-1988,ansix3.4-1968
-encoding.ISO-8859-9 : G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.9-1989,ansix3.4-1968
-encoding.ISO-8859-10 : G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.10-1992,ansix3.4-1968
-encoding.ISO-8859-11 : G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.11-2001,ansix3.4-1968
-encoding.ISO-8859-13 : G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.13-1998,ansix3.4-1968
-encoding.ISO-8859-14 : G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.14-1998,ansix3.4-1968
-encoding.ISO-8859-15 : G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.15-1999,ansix3.4-1968
-encoding.ISO-8859-16 : G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.16-2001,ansix3.4-1968
+encoding.C: G0,G1,ansix3.4-1968,ansix3.4-1968,iso8859.1-1987,ansix3.4-1968
+encoding.POSIX: G0,G1,ansix3.4-1968,ansix3.4-1968,iso8859.1-1987,ansix3.4-1968
+encoding.ANSI_X3.4-1968: G0,G1,ansix3.4-1968,ansix3.4-1968,ansix3.4-1968,ansix3.4-1968
+encoding.EUC-JP: G0,G1,ansix3.4-1968,jisx0208-1983,jisc6220-1969kana,jisx0212-1990
+encoding.EUC-KR: G0,G1,ansix3.4-1968,ksc5601-1987,ansix3.4-1968,ansix3.4-1968
+encoding.GB2312: G0,G1,ansix3.4-1968,gb2312-80,ansix3.4-1968,ansix3.4-1968
+encoding.ISO-8859-1: G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.1-1987,ansix3.4-1968
+encoding.ISO-8859-2: G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.2-1987,ansix3.4-1968
+encoding.ISO-8859-3: G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.3-1987,ansix3.4-1968
+encoding.ISO-8859-4: G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.4-1988,ansix3.4-1968
+encoding.ISO-8859-5: G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.5-1988,ansix3.4-1968
+encoding.ISO-8859-6: G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.6-1987,ansix3.4-1968
+encoding.ISO-8859-7: G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.7-1987,ansix3.4-1968
+encoding.ISO-8859-8: G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.8-1988,ansix3.4-1968
+encoding.ISO-8859-9: G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.9-1989,ansix3.4-1968
+encoding.ISO-8859-10: G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.10-1992,ansix3.4-1968
+encoding.ISO-8859-11: G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.11-2001,ansix3.4-1968
+encoding.ISO-8859-13: G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.13-1998,ansix3.4-1968
+encoding.ISO-8859-14: G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.14-1998,ansix3.4-1968
+encoding.ISO-8859-15: G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.15-1999,ansix3.4-1968
+encoding.ISO-8859-16: G0,G2,ansix3.4-1968,ansix3.4-1968,iso8859.16-2001,ansix3.4-1968
 encoding.UTF-8 : UTF-8,iso10646.1
 
 # other,*,iconv,UTF-8 is default action
-#encoding.SHIFT_JIS : other,SHIFT_JIS,iconv,UTF-8
-#encoding.BIG5 : other,BIG5,iconv,UTF-8
-#encoding.KOI8-U : other,KOI8-U,iconv,UTF-8
-#encoding.KOI8-T : other,KOI8-T,iconv,UTF-8
-#encoding.KOI8-R : other,KOI8-R,iconv,UTF-8
-#encoding.KOI-8 : other,KOI-8,iconv,UTF-8
-#encoding.CP1251 : other,CP1251,iconv,UTF-8
-#encoding.CP1255 : other,CP1255,iconv,UTF-8
-#encoding.TIS-620 : other,TIS-620,iconv,UTF-8
-#encoding.TCVN5712-1 : other,TCVN5712-1,iconv,UTF-8
-#encoding.GEORGIAN-PS : other,GEORGIAN-PS,iconv,UTF-8
-#encoding.GBK : other,GBK,iconv,UTF-8
-#encoding.GB18030 : other,GB18030,iconv,UTF-8
+#encoding.SHIFT_JIS: other,SHIFT_JIS,iconv,UTF-8
+#encoding.BIG5: other,BIG5,iconv,UTF-8
+#encoding.KOI8-U: other,KOI8-U,iconv,UTF-8
+#encoding.KOI8-T: other,KOI8-T,iconv,UTF-8
+#encoding.KOI8-R: other,KOI8-R,iconv,UTF-8
+#encoding.KOI-8: other,KOI-8,iconv,UTF-8
+#encoding.CP1251: other,CP1251,iconv,UTF-8
+#encoding.CP1255: other,CP1255,iconv,UTF-8
+#encoding.TIS-620: other,TIS-620,iconv,UTF-8
+#encoding.TCVN5712-1: other,TCVN5712-1,iconv,UTF-8
+#encoding.GEORGIAN-PS: other,GEORGIAN-PS,iconv,UTF-8
+#encoding.GBK: other,GBK,iconv,UTF-8
+#encoding.GB18030: other,GB18030,iconv,UTF-8
 
-###############################################################################
 #
-# color gamma value (default: 1.7)
+# other configuration
 #
-################################################################################
-color.gamma	:	1.7
+
+# color gamma value (default: 1.7)
+color.gamma: 1.7
+
+# scrollback history (default: 256)
+history: 512
diff -uNr jfbterm-0.4.7.orig/main.c jfbterm-0.4.7/main.c
--- jfbterm-0.4.7.orig/main.c	2004-05-11 03:03:44.000000000 +0900
+++ jfbterm-0.4.7/main.c	2005-12-17 12:41:37.000000000 +0900
@@ -59,6 +59,12 @@
 #include "util.h"
 #include "csv.h"
 #include "main.h"
+#ifdef JFB_WITH_LIBHANGUL
+#include "hinput.h"
+#endif
+#ifdef JFB_ENABLE_SCROLLBACK
+#include "scrollback.h"
+#endif
 
 #ifdef SYSCONFDIR
 #define	FILE_JFBTERM_CONF	SYSCONFDIR"/jfbterm.conf"
@@ -184,7 +190,7 @@
 	p->gExecShellArgv = NULL;
 	p->gConfFile = FILE_JFBTERM_CONF;
 	p->gConfEncoding = NULL;
-
+	signal(SIGCHLD, sigchld);
 	atexit(tapp_final_at_exit);
 }
 
@@ -371,6 +377,13 @@
 	char* cp;
 	const char* tn;
 	char* en;
+#ifdef JFB_WITH_LIBHANGUL
+	char* hangul_keyboard_type;
+	char* hangul_input_encoding;
+#endif
+#ifdef JFB_ENABLE_SCROLLBACK
+	char *histlen;
+#endif
 
 	util_privilege_init();
 	tapp_init(&gApp);
@@ -435,6 +448,19 @@
 	if (!tn) {
 		tn = "jfbterm";
 	}
+#ifdef JFB_ENABLE_SCROLLBACK
+	histlen = tcaps_find_first(&(gApp.gCaps), "history");
+	if(!histlen)
+		histlen = "256";
+	scrollback_set_histlen(atoi(histlen));
+#endif
+#ifdef JFB_WITH_LIBHANGUL
+	hangul_keyboard_type = tcaps_find_first(&(gApp.gCaps), "keyboard");
+	if(!hangul_keyboard_type) hangul_keyboard_type = "2";
+	hangul_input_encoding = tcaps_find_first(&(gApp.gCaps), "input");
+	if(!hangul_input_encoding) hangul_input_encoding = "locale";
+	hinput_init(hangul_keyboard_type, hangul_input_encoding);
+#endif
 	tterm_start(&gTerm, tn, en);
 
 	tfbm_close(&gFramebuffer);
diff -uNr jfbterm-0.4.7.orig/scrollback.c jfbterm-0.4.7/scrollback.c
--- jfbterm-0.4.7.orig/scrollback.c	1970-01-01 09:00:00.000000000 +0900
+++ jfbterm-0.4.7/scrollback.c	2005-12-17 12:41:37.000000000 +0900
@@ -0,0 +1,299 @@
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+#ifdef JFB_ENABLE_SCROLLBACK
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <sys/ioctl.h>
+#include "fbcommon.h"
+#include "font.h"
+#include "vterm.h"
+/*
+ * retrieve histlen size
+ */
+#define HISTLEN_DEFAULT 256
+static int histlen = 0;
+void scrollback_set_histlen(int len)
+{
+	if(0 < len && len < 10000)
+		histlen = len;
+	else
+		histlen = HISTLEN_DEFAULT;
+}
+
+int scrollback_get_histlen(void)
+{
+	return histlen;
+}
+
+/*
+ * keybord manipulation
+ */
+#include <linux/kd.h>
+#include <linux/keyboard.h>
+
+#define SHIFT_TABLE 1
+#define PAGE_UP_KEYCODE 104
+#define PAGE_DOWN_KEYCODE 109
+#define PAGE_UP_ACTION 0x0118
+#define PAGE_DOWN_ACTION 0x0119
+
+u_short scroll_forward = 0;
+u_short scroll_backward = 0;
+
+int scrollback_set_kb(u_short table, u_short keycode,
+		      u_short value, u_short *oldvalue, u_short readonly)
+{
+	struct kbentry ke;
+	ke.kb_table = table;
+	ke.kb_index = keycode;
+
+	if(ioctl(fileno(stdin), KDGKBENT, &ke))
+		return -1;
+
+	if(readonly == 0 && oldvalue)
+		*oldvalue = ke.kb_value;
+
+	ke.kb_value = value;
+
+	if(ioctl(fileno(stdin), KDSKBENT, &ke))
+		return -1;
+
+	return 0;
+}
+
+void scrollback_restore_key_atexit(void)
+{
+	if(scroll_backward)
+		scrollback_set_kb(SHIFT_TABLE, PAGE_UP_KEYCODE,
+				  scroll_backward, 0, 0);
+	if(scroll_forward)
+		scrollback_set_kb(SHIFT_TABLE, PAGE_DOWN_KEYCODE,
+				  scroll_forward, 0, 0);
+}
+
+void scrollback_restore_key(void)
+{
+	if(scroll_backward)
+		scrollback_set_kb(SHIFT_TABLE, PAGE_UP_KEYCODE,
+				  scroll_backward, 0, 1);
+	if(scroll_forward)
+		scrollback_set_kb(SHIFT_TABLE, PAGE_DOWN_KEYCODE,
+				  scroll_forward, 0, 1);
+}
+
+int scrollback_disable_key(u_short readonly)
+{
+	if(scrollback_set_kb(SHIFT_TABLE, PAGE_UP_KEYCODE,
+			     PAGE_UP_ACTION, &scroll_backward, readonly))
+		return -1;
+	if(scrollback_set_kb(SHIFT_TABLE, PAGE_DOWN_KEYCODE,
+			     PAGE_DOWN_ACTION, &scroll_forward, readonly))
+		return -1;
+	atexit(scrollback_restore_key_atexit);
+	return 0;
+}
+
+/*
+ * scrollback memory management
+ */
+static inline u_int scrollback_coord_to_index(TVterm *p, u_int x, u_int y)
+{
+	return (p->textHead + x + y * p->xcap4) % (p->xcap4 * p->histsize);
+}
+
+void scrollback_move_to_hist(TVterm *p, int dst, int src, int n)
+{
+	memmove(p->htext+dst, p->text+src, n*sizeof(u_int));
+	memmove(p->hattr+dst, p->attr+src, n);
+	memmove(p->hflag+dst, p->flag+src, n);
+}
+
+void scrollback_move_from_hist(TVterm *p, int dst, int src, int n)
+{
+	memmove(p->text+dst, p->htext+src, n*sizeof(u_int));
+	memmove(p->attr+dst, p->hattr+src, n);
+	memmove(p->flag+dst, p->hflag+src, n);
+}
+
+/*
+ * crippled circular queue
+ */
+static int queue_front = -1;
+static int queue_rear = 0;
+
+int queue_get_size(TVterm *p)
+{
+	if(queue_front == -1)
+		return 0;
+	else if(queue_front == queue_rear)
+		return p->histsize;
+	return queue_rear - queue_front;
+}
+
+int queue_line_rel_to_abs(TVterm *p, int rel)
+{
+	u_int queue_size = queue_get_size(p);
+	if(0 <= rel && rel < queue_size)
+		return (queue_rear - (rel + 1) + p->histsize) % p->histsize;
+	return -1;
+}
+
+void queue_insert_line(TVterm *p, int src)
+{
+	int dst, queue_size;
+	dst = scrollback_coord_to_index(p, 0, queue_rear);
+	scrollback_move_to_hist(p, dst, src, p->xcap4);
+
+	queue_size = queue_get_size(p);
+	if(queue_size == 0 || queue_size == p->histsize)
+		queue_front = ++queue_front % p->histsize;
+	queue_rear = ++queue_rear % p->histsize;
+}
+
+/*
+ * scrollback refresh routine
+ */
+void scrollback_refresh(TVterm *p, int page)
+{
+	int page_front, page_rear, queue_size;
+	int i, iy, x, y;
+
+	u_int w, gw, chlw, lang;
+	u_char bc, fc, fg, ch, ch2;
+	TFont *pf;
+	const u_char *glyph;
+
+	tvterm_hide_cursor(p);
+	page_front = (p->ycap / 2) * page;
+	queue_size = queue_get_size(p);
+	if(page_front > queue_size)
+		page_front = queue_size;
+	page_rear = page_front - p->ycap;
+	if(page_rear == 0) page_rear = 0;
+
+	for(iy = page_front - 1; iy >= page_rear; iy--) {
+		y = queue_line_rel_to_abs(p, iy);
+		for(x = 0; x < p->xcap; x++) {
+			i = scrollback_coord_to_index(p, x, y);
+			p->hflag[i] = p->hflag[i] & ~CLEAN_S;
+		}
+	}
+
+	for(iy = page_front - 1; iy >= page_rear; iy--) {
+		y = queue_line_rel_to_abs(p, iy);
+		for(x = 0; x < p->xcap; x++) {
+			i = scrollback_coord_to_index(p, x, y);
+			w = 1;
+			fg = p->hflag[i];
+			if(fg & CLEAN_S)
+				continue;
+			fc = p->hattr[i] & 0xf;
+			bc = p->hattr[i] >> 4;
+			chlw = p->htext[i];
+			ch2 = (chlw >> 8) & 0xff;
+			ch = chlw & 0xff;
+			lang = (chlw >> 24) & 0xff;
+			p->hflag[i] |= CLEAN_S;
+			if(fg & CODEIS_1) {
+				pf = &(gFont[lang]);
+				i++;
+				p->hflag[i] |= CLEAN_S;
+				w = 2;
+			}
+			else
+				pf = &(gFont[lang]);
+			glyph = pf->conv(pf, chlw, &gw);
+			gFramebuffer.cap.fill(&gFramebuffer,
+				gFontsWidth * x, gFontsHeight * (page_front - 1 - iy),
+				gFontsWidth * w, gFontsHeight, bc);
+			if(chlw == 0)
+				continue;
+			gFramebuffer.cap.overlay(&gFramebuffer,
+				gFontsWidth * x, gFontsHeight * (page_front - 1 - iy),
+				glyph, gw, pf->height, pf->bytew, fc);
+		}
+	}
+
+	for(y = 0; y < (p->ycap - page_front); y++) {
+		for(x = 0; x < p->xcap; x++) {
+			i = scrollback_coord_to_index(p, x, y);
+			p->flag[i] = p->flag[i] & ~CLEAN_S;
+		}
+	}
+
+	for(y = 0; y < (p->ycap - page_front); y++) {
+		for(x = 0; x < p->xcap; x++) {
+			i = scrollback_coord_to_index(p, x, y);
+			w = 1;
+			fg = p->flag[i];
+			if(fg & CLEAN_S)
+				continue;
+			fc = p->attr[i] & 0xf;
+			bc = p->attr[i] >> 4;
+			chlw = p->text[i];
+			ch2 = (chlw >> 8) & 0xff;
+			ch = chlw & 0xff;
+			lang = (chlw >> 24) & 0xff;
+			p->flag[i] |= CLEAN_S;
+			if(fg & CODEIS_1) {
+				pf = &(gFont[lang]);
+				i++;
+				p->flag[i] |= CLEAN_S;
+				w = 2;
+			}
+			else
+				pf = &(gFont[lang]);
+			glyph = pf->conv(pf, chlw, &gw);
+			gFramebuffer.cap.fill(&gFramebuffer,
+				gFontsWidth * x, gFontsHeight * (y + page_front),
+				gFontsWidth * w, gFontsHeight, bc);
+			if(chlw == 0)
+				continue;
+			gFramebuffer.cap.overlay(&gFramebuffer,
+				gFontsWidth * x, gFontsHeight * (y + page_front),
+				glyph, gw, pf->height, pf->bytew, fc);
+		}
+	}
+
+	for(y = 0; y < p->ycap; y++) {
+		for(x = 0; x < p->xcap; x++) {
+			i = scrollback_coord_to_index(p, x, y);
+			p->flag[i] = p->flag[i] & ~CLEAN_S;
+		}
+	}
+}
+
+/*
+ * scrollback actions
+ */
+static int pageno = 0;
+void scrollback_init_pageno(void)
+{
+	pageno = 0;
+}
+
+void scrollback_scroll_up(TVterm *p)
+{
+	int max_scroll_pages;
+	max_scroll_pages = queue_get_size(p) / (p->ycap / 2);
+	if(max_scroll_pages >= pageno)
+		scrollback_refresh(p, ++pageno);
+}
+
+void scrollback_scroll_down(TVterm *p)
+{
+	if(pageno <= 0)
+		tvterm_refresh(p);
+	else
+		scrollback_refresh(p, --pageno);
+}
+
+int scrollback_is_on(void)
+{
+	if(pageno)
+		return 1;
+	return 0;
+}
+#endif
diff -uNr jfbterm-0.4.7.orig/scrollback.h jfbterm-0.4.7/scrollback.h
--- jfbterm-0.4.7.orig/scrollback.h	1970-01-01 09:00:00.000000000 +0900
+++ jfbterm-0.4.7/scrollback.h	2005-12-17 12:41:37.000000000 +0900
@@ -0,0 +1,19 @@
+#ifdef JFB_ENABLE_SCROLLBACK
+#ifndef HAVE_SCROLLBACK_H
+#define HAVE_SCROLLBACK_H
+void scrollback_set_histlen(int len);
+int scrollback_get_histlen(void);
+
+void scrollback_restore_key_atexit(void);
+void scrollback_restore_key(void);
+int scrollback_disable_key(u_short readonly);
+
+void queue_insert_line(TVterm *p, int src);
+
+void scrollback_init_pageno(void);
+void scrollback_scroll_up(TVterm *p);
+void scrollback_scroll_down(TVterm *p);
+
+int scrollback_is_on(void);
+#endif
+#endif
